package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.BitmapData;
	import flash.display.BlendMode;
	import flash.display.Shape;
	import flash.display.StageQuality;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.net.SharedObject;
	
	import flashx.textLayout.formats.Float;
	import flashx.textLayout.operations.CutOperation;
	
	import org.flixel.*;

	public class DiscreteGameState extends FlxState
	{	
		
		public var fps:Number=25;
		public var timer:Number=0;
		
		public var px:int;
		public var py:int;
		public var pdirs:Vector.<uint>;
		public var pdir:uint;
		
		public var bmd:BitmapData;
		public var background:FlxSprite;
		public var playwidth:int=125;
		public var playheight:int=125;
		
		public var player:FlxSprite;
		
		public var collectablecount:int=5;
		public var collectables:FlxGroup;
		
		public var scoretxt:FlxText;
		public var score:int=0;
		
		[Embed(source="data/piece.png")] public static var ImgPiece:Class;
		[Embed(source="data/bg.png")] public static var ImgBG:Class;
		
		[Embed(source="data/pickup.mp3")] public static var SndCollect:Class;
		[Embed(source="data/teleport.mp3")] public static var SndTeleport:Class;
		[Embed(source="data/dead.mp3")] public static var SndDie:Class;
		
		override public function create():void
		{
			super.create();
			FlxG.stage.quality = flash.display.StageQuality.LOW;
			FlxG.camera.bgColor=FlxG.BLACK;
			FlxG.bgColor=FlxG.BLACK;
			pdirs = new Vector.<uint>();
			pdirs.push(FlxObject.RIGHT);
			background = new FlxSprite(0,0,ImgBG);
			bmd = background.pixels.clone();
			background.pixels=bmd;
			add(background);
			px=10;//playwidth/6;
			py=10;//playheight/2;
			player = new FlxSprite(px,py);
			player.pixels = FlxG.createBitmap(1,1,FlxG.BLACK,true);
			add(player);
			
			collectables = new FlxGroup();
			add(collectables);
			while (collectables.length<collectablecount)
			{
				var s:FlxSprite = new FlxSprite(int(Math.random()*(playwidth-10)+5),int(Math.random()*(playheight-10)+5),ImgPiece);
				collectables.add(s);
			}
			
			timer=0;	
			
			scoretxt = new FlxText(4,playheight-2,playwidth-4,"score:"+"0");
			scoretxt.color=FlxG.WHITE;
			add(scoretxt);
			
			var recordtxt:FlxText = new FlxText(4,playheight-2,playwidth-4,"max:"+FlxG.score);
			recordtxt.alignment="right";
			recordtxt.color=FlxG.WHITE;
			add(recordtxt);
		}
		
		public var deathradius:Number=0;
		override public function update():void
		{
			if (dead)
			{
				deathradius+=FlxG.elapsed;
				
				var drawing:Shape = new Shape();
				
				drawing.graphics.lineStyle(1, 0xff0000);
				drawing.graphics.drawCircle(px,py,deathradius*100);				
				bmd.draw(drawing,new Matrix());				
				background.pixels=bmd;
				
				if (deathradius>1.5)
				{
					FlxG.switchState(new DiscreteGameState());
				}
				super.update();
				return;
			}
			
			if (pdirs.length==0)
			{
				pdirs.push(pdir);
			}
			
			if (FlxG.keys.justPressed("UP"))
			{
				if (pdirs.length==0 || (pdirs[pdirs.length-1]!=FlxObject.UP && pdirs[pdirs.length-1]!=FlxObject.DOWN))
				{
					pdirs.push(FlxObject.UP);
				}
			}
			if (FlxG.keys.justPressed("DOWN"))
			{
				if (pdirs.length==0 || (pdirs[pdirs.length-1]!=FlxObject.UP && pdirs[pdirs.length-1]!=FlxObject.DOWN))
				{
					pdirs.push(FlxObject.DOWN);
				}
			}
			if (FlxG.keys.justPressed("LEFT"))
			{
				if (pdirs.length==0 || (pdirs[pdirs.length-1]!=FlxObject.LEFT && pdirs[pdirs.length-1]!=FlxObject.RIGHT))
				{
					pdirs.push(FlxObject.LEFT);
				}
			}
			if (FlxG.keys.justPressed("RIGHT"))
			{
				if (pdirs.length==0 || (pdirs[pdirs.length-1]!=FlxObject.LEFT && pdirs[pdirs.length-1]!=FlxObject.RIGHT))
				{
					pdirs.push(FlxObject.RIGHT);
				}
			}
			
			timer+=FlxG.elapsed;
			if(timer>1/fps||pdirs.length>1)
			{
				timer=0;
				
				
				for (var i:int=0;i<pdirs.length;i++)
				{
					pdir=pdirs[i];
					logictick();
				}
				pdirs = new Vector.<uint>();
			}
			super.update();
		}
		
		public function logictick():void
		{
			bmd.setPixel(px,py,FlxG.BLACK);
			background.pixels=bmd;
			switch(pdir)
			{
				case FlxObject.UP:
					py--;
					break;
				case FlxObject.DOWN:
					py++;
					break;
				case FlxObject.LEFT:
					px--;
					break;
				case FlxObject.RIGHT:
					px++;
					break;
			}
			player.x=px;
			player.y=py;
			
			if (bmd.getPixel(px,py)==0x000000)
			{
				trace("overblack");
				var dx:int=0;
				var dy:int=0;
				switch(pdir)
				{
					case FlxObject.UP:
						dy=-1;
						break;
					case FlxObject.DOWN:
						dy=+1;
						break;
					case FlxObject.LEFT:
						dx=-1;
						break;
					case FlxObject.RIGHT:
						dx=+1;
						break;
				}
				
				var tx:int=px+dx;
				var ty:int=py+dy;
				var found:Boolean=true;
				/*
				while(bmd.getPixel(tx,ty)!=0xFFFFFF)
				{
					tx+=dx;
					ty+=dy;
					if (tx<0 || ty < 0 || tx>=playwidth || ty>=playheight)
					{
						found=false;	
						break;
					}
				}*/
				if (found)
				{
					while(bmd.getPixel(tx,ty)!=0x000000)
					{
						tx+=dx;
						ty+=dy;
						if (tx<0 || ty < 0 || tx>=playwidth || ty>=playheight)
						{
							found=false;
							break;
						}
					}
				}
				
				if (found)
				{
					tx+=dx;
					ty+=dy;
					if (tx<0 || ty < 0 || tx>=playwidth || ty>=playheight)
					{
						found=false;
					}
				}
				
				if (found)
				{
					px=tx;
					py=ty;
					FlxG.play(SndTeleport);
				}
				else
				{
					Die();
				}
				
			}
			if (px<0 || py < 0 || px>=playwidth || py>=playheight)
			{
				Die();
			}
			TryCollect();						
		}
		
		
		private var dead:Boolean=false;
		public function Die():void
		{
			if (dead==false)
			{
				FlxG.play(SndDie).survive=true;
				dead=true;
				FlxG.score = Math.max(FlxG.score,score);
				
				var save:FlxSave = new FlxSave();			
				if (save.bind("Underling"))
				{
					save.data.score = FlxG.score;
					save.close();
				}
				
			}
		}
		
		public function TryCollect():void
		{
			for (var i:int=collectables.length-1;i>=0;i--)
			{
				var c:FlxSprite = collectables.members[i];
				if (c.pixels.hitTest(new Point(c.x,c.y),0xff,(new Point(px+0.5,py+0.5))))
				{
					
					FlxG.play(SndCollect);
					c.x=int(Math.random()*(playwidth-10)+5);
					c.y=int(Math.random()*(playheight-10)+5);
					
					if (score<7)
					{
						fps*=1.025;
					}
					score++;
					if (score>FlxG.score)
					{
						scoretxt.color=0xff00ff00;
					}
					scoretxt.text="score:"+score.toString();
				}
			}
		}
		
	}
	
}