package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	import org.flixel.FlxG;
	import org.flixel.system.FlxPreloader;

	public class Preloader extends FlxPreloader
	{
		/**
		 * @private
		 */
		protected var _logoText:TextField;
		
		public function Preloader() 
		{
			super();
		}
		
		override protected function create():void
		{
			_min = 0;
			//if(!FlxG.debug)
				_min = minDisplayTime*1000;
			_buffer = new Sprite();
			_buffer.scaleX = 2;
			_buffer.scaleY = 2;
			addChild(_buffer);
			_width = stage.stageWidth/_buffer.scaleX;
			_height = stage.stageHeight/_buffer.scaleY;
			_buffer.addChild(new Bitmap(new BitmapData(_width, _height, false, 0x313210)));	
			_bmpBar = new Bitmap(new BitmapData(7,1,false,0xD4D943));
			_bmpBar.x = _width / 2 + 20;
			_bmpBar.y = _height;
			_buffer.addChild(_bmpBar);
			_logoText = new TextField();
			_logoText.defaultTextFormat = new TextFormat("system", 8, 0xD4D943);
			_logoText.embedFonts = true;
			_logoText.selectable = false;
			_logoText.multiline = false;
			_logoText.x = 0;
			_logoText.y = _height - 15;
			_logoText.width = 100;
			_buffer.addChild(_logoText);
			_logo = new ImgLogo();
			_logo.scaleX = _logo.scaleY = 2;
			_logo.x = 60;
			_logo.y = _logoText.y;
			_buffer.addChild(_logo);
			_text = new TextField();
			_text.defaultTextFormat = new TextFormat("system",8,0xD4D943);
			_text.embedFonts = true;
			_text.selectable = false;
			_text.multiline = false;
			_text.x = _bmpBar.x - 80;
			_text.y = _height;
			_text.width = 80;
			_buffer.addChild(_text);
			var bitmap:Bitmap = new Bitmap(new BitmapData(_width, _height, false, 0xffffff));
			var i:uint = 0;
			var j:uint = 0;
			while(i < _height)
			{
				j = 0;
				while(j < _width)
					bitmap.bitmapData.setPixel(j++,i,0);
				i+=2;
			}
			bitmap.x = (_width - bitmap.width) / 2;
			bitmap.smoothing = true;
			bitmap.blendMode = "overlay";
			bitmap.alpha = 0.25;
			_buffer.addChild(bitmap);
			
			
			this.className="HelloWorld";
		}
		
		override protected function update(Percent:Number):void
		{
			_bmpBar.scaleY = -Percent * _height;
			_text.y = _bmpBar.scaleY + _height;
			_text.text = "Loading: "+Math.floor(Percent*100)+"%";
			_text.setTextFormat(_text.defaultTextFormat);
			_logoText.text = "Powered by Flixel";
			_logoText.setTextFormat(_logoText.defaultTextFormat);
		}
		
		override protected function destroy():void
		{
			super.destroy();
			_logoText = null;
		}
	}
}